"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _webinyModel = require("webiny-model");

var _fecha = _interopRequireDefault(require("fecha"));

class DateAttribute extends _webinyModel.DateAttribute {
  setStorageValue(value) {
    if (value === null) {
      return super.setStorageValue(value);
    }

    if (value instanceof Date) {
      return super.setStorageValue(value);
    }

    return super.setStorageValue(_fecha.default.parse(value, "YYYY-MM-DD HH:mm:ss"));
  }

  async getStorageValue() {
    const value = await _webinyModel.DateAttribute.prototype.getStorageValue.call(this);

    if (value instanceof Date) {
      return _fecha.default.format(value, "YYYY-MM-DD HH:mm:ss");
    }

    return value;
  }

}

var _default = DateAttribute;
exports.default = _default;
//# sourceMappingURL=dateAttribute.js.map