"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _webinyEntity = require("webiny-entity");

var _attributes = require("./attributes");

/**
 * Contains basic attributes. If needed, this class can be extended to add additional attributes,
 * and then be set as a new attributes container as the default one.
 */
class MySQLAttributesContainer extends _webinyEntity.EntityAttributesContainer {
  boolean() {
    const model = this.getParentModel();
    model.setAttribute(this.name, new _attributes.BooleanAttribute(this.name, this));
    return model.getAttribute(this.name);
  }

  date() {
    const model = this.getParentModel();
    model.setAttribute(this.name, new _attributes.DateAttribute(this.name, this));
    return model.getAttribute(this.name);
  }

  array() {
    const model = this.getParentModel();
    model.setAttribute(this.name, new _attributes.ArrayAttribute(this.name, this));
    return model.getAttribute(this.name);
  }

  object() {
    const model = this.getParentModel();
    model.setAttribute(this.name, new _attributes.ObjectAttribute(this.name, this));
    return model.getAttribute(this.name);
  }

  model(model) {
    const parent = this.getParentModel();
    parent.setAttribute(this.name, new _attributes.ModelAttribute(this.name, this, model));
    return parent.getAttribute(this.name);
  }

  models(model) {
    const parent = this.getParentModel();
    parent.setAttribute(this.name, new _attributes.ModelsAttribute(this.name, this, model));
    return parent.getAttribute(this.name);
  }

}

var _default = MySQLAttributesContainer;
exports.default = _default;
//# sourceMappingURL=mysqlAttributesContainer.js.map