"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _get2 = _interopRequireDefault(require("lodash/get"));

var _isNumber2 = _interopRequireDefault(require("lodash/isNumber"));

var _isString2 = _interopRequireDefault(require("lodash/isString"));

var _has2 = _interopRequireDefault(require("lodash/has"));

var _webinyModel = require("webiny-model");

var _jsonArrayStrictEquality = _interopRequireDefault(require("./../comparison/jsonArrayStrictEquality"));

var _jsonArrayFindValue = _interopRequireDefault(require("./../comparison/jsonArrayFindValue"));

const eq = {
  canProcess: ({
    key,
    value,
    statement
  }) => {
    if (key.charAt(0) === "$") {
      return false;
    }

    if ((0, _has2.default)(value, "$eq")) {
      return true;
    } // Valid values are 1, '1', null, true, false.


    if ((0, _isString2.default)(value) || (0, _isNumber2.default)(value) || [null, true, false].includes(value)) {
      return true;
    }

    const instance = typeof statement.entity === "function" ? new statement.entity() : statement.entity;
    const attribute = instance.getAttribute(key);
    return attribute instanceof _webinyModel.ArrayAttribute && Array.isArray(value);
  },
  process: ({
    key,
    value,
    statement
  }) => {
    value = (0, _get2.default)(value, "$eq", value);

    if (value === null) {
      return "`" + key + "` IS NULL";
    }

    const instance = typeof statement.entity === "function" ? new statement.entity() : statement.entity;
    const attribute = instance.getAttribute(key);

    if (attribute instanceof _webinyModel.ArrayAttribute) {
      // Match all values (strict array equality check)
      if (Array.isArray(value)) {
        return _jsonArrayStrictEquality.default.process({
          key,
          value: {
            $jsonArrayStrictEquality: value
          },
          statement
        });
      } else {
        return _jsonArrayFindValue.default.process({
          key,
          value: {
            $jsonArrayFindValue: value
          },
          statement
        });
      }
    }

    return "`" + key + "` = " + statement.escape(value);
  }
};
var _default = eq;
exports.default = _default;
//# sourceMappingURL=eq.js.map