"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _get2 = _interopRequireDefault(require("lodash/get"));

var _has2 = _interopRequireDefault(require("lodash/has"));

var _webinyModel = require("webiny-model");

var _or = _interopRequireDefault(require("../logical/or"));

const inOperator = {
  canProcess: ({
    key,
    value,
    statement
  }) => {
    if (key.charAt(0) === "$") {
      return false;
    }

    if ((0, _has2.default)(value, "$in")) {
      return true;
    }

    const instance = typeof statement.entity === "function" ? new statement.entity() : statement.entity;
    const attribute = instance.getAttribute(key);
    return Array.isArray(value) && !(attribute instanceof _webinyModel.ArrayAttribute);
  },
  process: ({
    key,
    value,
    statement
  }) => {
    value = (0, _get2.default)(value, "$in", value);
    const instance = typeof statement.entity === "function" ? new statement.entity() : statement.entity;
    const attribute = instance.getAttribute(key);

    if (attribute instanceof _webinyModel.ArrayAttribute) {
      const andValue = value.map(v => {
        return {
          [key]: {
            $jsonArrayFindValue: v
          }
        };
      });
      return _or.default.process({
        key,
        value: andValue,
        statement
      });
    }

    return "`" + key + "` IN(" + value.map(item => statement.escape(item)).join(", ") + ")";
  }
};
var _default = inOperator;
exports.default = _default;
//# sourceMappingURL=in.js.map