"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _or = _interopRequireDefault(require("../logical/or"));

var _and = _interopRequireDefault(require("../logical/and"));

const search = {
  canProcess: ({
    key
  }) => {
    return key === "$search";
  },
  process: ({
    value,
    statement
  }) => {
    const columns = value.columns.map(columns => {
      return {
        [columns]: {
          $like: "%" + value.query + "%"
        }
      };
    });

    if (value.operator === "and") {
      return _and.default.process({
        key: "$and",
        value: columns,
        statement
      });
    }

    return _or.default.process({
      key: "$or",
      value: columns,
      statement
    });
  }
};
var _default = search;
exports.default = _default;
//# sourceMappingURL=search.js.map