"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _isPlainObject2 = _interopRequireDefault(require("lodash/isPlainObject"));

var _isArray2 = _interopRequireDefault(require("lodash/isArray"));

const and = {
  canProcess: ({
    key
  }) => {
    return key === "$and";
  },
  process: ({
    value,
    statement
  }) => {
    let output = "";

    switch (true) {
      case (0, _isArray2.default)(value):
        value.forEach(object => {
          for (const [andKey, andValue] of Object.entries(object)) {
            if (output === "") {
              output = statement.process({
                [andKey]: andValue
              });
            } else {
              output += " AND " + statement.process({
                [andKey]: andValue
              });
            }
          }
        });
        break;

      case (0, _isPlainObject2.default)(value):
        for (const [andKey, andValue] of Object.entries(value)) {
          if (output === "") {
            output = statement.process({
              [andKey]: andValue
            });
          } else {
            output += " AND " + statement.process({
              [andKey]: andValue
            });
          }
        }

        break;

      default:
        throw Error("$and operator must receive an object or an array.");
    }

    return "(" + output + ")";
  }
};
var _default = and;
exports.default = _default;
//# sourceMappingURL=and.js.map