"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _values2 = _interopRequireDefault(require("lodash/values"));

var _keys2 = _interopRequireDefault(require("lodash/keys"));

var _statement = _interopRequireDefault(require("./statement"));

class Insert extends _statement.default {
  generate() {
    const options = this.options;
    const columns = (0, _keys2.default)(options.data).map(c => "`" + c + "`").join(", ");
    const insertValues = (0, _values2.default)(options.data).map(value => this.escape(value)).join(", ");

    if (!options.onDuplicateKeyUpdate) {
      return `INSERT INTO \`${options.table}\` (${columns}) VALUES (${insertValues})`;
    }

    const updateValues = [];

    for (const [key, value] of Object.entries(options.data)) {
      updateValues.push(key + " = " + this.escape(value));
    }

    return `INSERT INTO \`${options.table}\` (${columns}) VALUES (${insertValues}) ON DUPLICATE KEY UPDATE ${updateValues.join(", ")}`;
  }

}

var _default = Insert;
exports.default = _default;
//# sourceMappingURL=insert.js.map