"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _statement = _interopRequireDefault(require("./statement"));

var _sqlstring = _interopRequireDefault(require("sqlstring"));

class Select extends _statement.default {
  generate() {
    const options = this.options;

    if (options.sql) {
      const {
        query,
        values
      } = options.sql;

      if (typeof query === "string") {
        return _sqlstring.default.format(query, values);
      }
    }

    let output = `SELECT`;

    if (options.calculateFoundRows) {
      output += ` SQL_CALC_FOUND_ROWS`;
    }

    output += this.getColumns(options);
    output += ` FROM \`${options.table}\``;
    output += this.getWhere(options);
    output += this.getGroup(options);
    output += this.getOrder(options);
    output += this.getLimit(options);
    output += this.getOffset(options);
    return output;
  }

}

var _default = Select;
exports.default = _default;
//# sourceMappingURL=select.js.map