"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _statement = _interopRequireDefault(require("./statement"));

class Update extends _statement.default {
  generate() {
    const values = [],
          options = this.options;

    for (const [key, value] of Object.entries(options.data)) {
      values.push("`" + key + "` = " + this.escape(value));
    }

    let output = `UPDATE \`${options.table}\` SET ${values.join(", ")}`;
    output += this.getWhere(options);
    output += this.getOrder(options);
    output += this.getLimit(options);
    output += this.getOffset(options);
    return output;
  }

}

var _default = Update;
exports.default = _default;
//# sourceMappingURL=update.js.map